<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header display-flex">
                        <div class="col-3 mg-t-5">Prescription</div>
                        <div class="col-9">
                            <button class="btn btn-primary float-right" @click="createPrescription()">
                                Create new
                            </button>
                        </div>
                    </div>

                    <div class="card-body">
                        <div class="alert alert-success" role="alert" v-if="success">
                            {{ success }}
                        </div>
                        <div class="alert alert-danger" role="alert" v-if="error">
                            {{ error }}
                        </div>
                        <table class="table">
                            <thead>
                            <tr>
                                <th>Drug</th>
                                <th>Description</th>
                                <th>Patient</th>
                                <th>Created</th>
                                <th>Actions</th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr v-for="prescription in prescriptions.data" :key="prescription.id">
                                <td>{{ prescription.drug.name }}</td>
                                <td>{{ prescription.description }}</td>
                                <td>{{ prescription.user.email }}</td>
                                <td>{{ formatDate(prescription.created_at) }}</td>
                                <td>
                                    <div class="btn-group" role="group">
                                        <button class="btn btn-danger" @click="deletePrescription(prescription.id)">Delete</button>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <pagination :data="prescriptions" @pagination-change-page="fetchPrescriptions"></pagination>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from "axios";
import configs from "../../config";
import pagination from 'laravel-vue-pagination';

export default {
    components: { pagination },
    data() {
        return {
            prescriptions: [],
            loading: null,
            error: null,
            success: null
        }
    },

    mounted() {
        this.fetchPrescriptions();
    },

    methods: {
        fetchPrescriptions() {
            this.loading = true;
            axios
                .get(configs.DOCTOR_PRESCRIPTIONS_URL)
                .then(response => {
                    this.loading = false;
                    this.prescriptions = response.data;
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        deletePrescription(id) {
            axios
                .delete(configs.PRESCRIPTIONS_URL + `/${id}`)
                .then(response => {
                    this.prescriptions.splice(this.prescriptions.map(data => data.id).indexOf(id), 1)
                    this.success = response.data
                })
                .catch(error => {
                    this.loading = false;
                    this.error = error.response.data.message || error.message;
                });
        },

        createPrescription() {
            window.location.href = configs.PRESCRIPTIONS_URL + '/create';
        },

        formatDate(dateString) {
            let date = new Date(dateString);
            let offset = date.getTimezoneOffset();

            return new Date(date.getTime() - (offset*60*1000)).toISOString()
                .replace(/T/, ' ')
                .replace(/\..+/, '');
        }
    }
}
</script>
